﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=11
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Private timMessages1 As Timer
	Private timMessages2 As Timer

	Public emEmail As clsEmail

	Public emEmailTo As String
	Public emEmailBC As String
	Public emGmail As String
	Public strEmailTitle As String
	Public strEmailBody As String

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private IME As IME
	Private CSB As CSBuilder

	'v0.1  (22/11/2021) - Initial development
	Private strVersion As String = "v0.1"
	Private lblVersion As Label
	
	Private lblMessages As Label
	Private strMessagesText As String
	Private strSaveMessagesText As String

	Private pnlMondayAvailability As Panel
	Private lblMonday As Label
	Private lblMondayDate As Label
	Private lblMondayAvailability As Label
	Private lblMondayAvailabilityComments As Label
	Private lblMonday As Label
	Private pnlTuesdayAvailability As Panel
	Private lblTuesdayDate As Label
	Private lblTuesdayAvailability As Label
	Private lblTuesdayAvailabilityComments As Label
	Private lblTuesday As Label
	Private pnlWednesdayAvailability As Panel
	Private lblWednesdayDate As Label
	Private lblWednesdayAvailability As Label
	Private lblWednesdayAvailabilityComments As Label
	Private lblWednesday As Label
	Private pnlThursdayAvailability As Panel
	Private lblThursdayDate As Label
	Private lblThursdayAvailability As Label
	Private lblThursdayAvailabilityComments As Label
	Private lblThursday As Label
	Private pnlFridayAvailability As Panel
	Private lblFridayDate As Label
	Private lblFridayAvailability As Label
	Private lblFridayAvailabilityComments As Label
	Private lblFriday As Label
	Private pnlSaturdayAvailability As Panel
	Private lblSaturdayDate As Label
	Private lblSaturdayAvailability As Label
	Private lblSaturdayAvailabilityComments As Label
	Private lblSaturday As Label
	Private pnlSundayAvailability As Panel
	Private lblSundayDate As Label
	Private lblSundayAvailability As Label
	Private lblSundayAvailabilityComments As Label
	Private lblSunday As Label
	Private pnlPrev As Panel
	Private lblPrevWC As Label
	Private lblPrevWCDate As Label
	Private pnlCurrent As Panel
	Private lblEmailToStore As Label
	Private lblCurrentWCDate As Label
	Private pnlNext As Panel
	Private lblNextWC As Label
	Private lblNextWCDate As Label
	Private imgExit As ImageView
	Private pnlComments As Panel
	Private lblDateDate As Label
	Private lblOldComments As Label
	Private edtNewComments As EditText
	Private lblCancel As Label
	Private lblUpdate As Label
	
	Private strSQLQuery As String

	Private WAAvailabilitySet As ResultSet
	Private strAvailabilityWCDate As String
	Private strAvailabilityStatus As String
	Private strAvailabilityEmailDateTime As String
	
	Private WACodesSet As ResultSet
	Private intCodesAvailabilityCode As Int
	Private strCodesAvailabilityDescription As String
	
	Private lstAvailabilityDescription(1) As List
	Private whlAvailabilityDescription As clsWheel

	Private lstAvailabilityWCDate(1) As List
	Private bolStatusSet As Boolean
	Private intAvailabilityWCDatePos As Int
	Private intTotalAvailabilityRecords As Int
	
	Private strEmailHeader As String
	Private strEmailDetail As String
	Private mapPhotos As Map

	Private strNothing As String = ""
	Private strNoComments As String = "No Comments"
	Private strWC As String = "W/C"
	Private strR As String = "R"
	Private int0 As Int = 0
	Private strDisplayDate As String
	Private lngDisplayDate As Long
	Private strDisplayTime As String
	Private intAvailabilityCodeDay As Int
	Private strAvailabilityComments As String

End Sub

Sub Activity_Create(FirstTime As Boolean)

	IME.Initialize("IME")

	emGmail = "xxx"
	emEmailTo = "xxx"
	emEmailBC = "xxx"

	emEmail.Initialize(Me, "smtp.gmail.com", "pop.gmail.com", emGmail, "xxxx", emGmail, emEmailTo)

	Activity.LoadLayout("WAS10")

	lblVersion.Text = strVersion
	
	IME.SetLengthFilter(edtNewComments, 50)
'	edtNewComments.InputType = Bit.Or(edtNewComments.INPUT_TYPE_TEXT, 8192)
'	SetEllipsize(lblMondayAvailabilityComments, "END")
'	SetEllipsize(lblTuesdayAvailabilityComments, "END")
'	SetEllipsize(lblWednesdayAvailabilityComments, "END")
'	SetEllipsize(lblThursdayAvailabilityComments, "END")
'	SetEllipsize(lblFridayAvailabilityComments, "END")
'	SetEllipsize(lblSaturdayAvailabilityComments, "END")
'	SetEllipsize(lblSundayAvailabilityComments, "END")
	
	SelectCodesAvailabilityDescriptionList
	
	SelectAvailabilityWCDates

	SelectAvailabilityRecord
	
	DisplayAvailabilityDetails
	
	timMessages1.Initialize("timMessages1", 400)
	timMessages1.Enabled = False
	timMessages2.Initialize("timMessages2", 2600)
	timMessages2.Enabled = False

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub SetEllipsize(TextView As Label, Mode As String)
	
	Dim r As Reflector
	r.Target = TextView
	r.RunMethod2("setLines", 1, "java.lang.int")
	r.RunMethod2("setHorizontallyScrolling", True, "java.lang.boolean")
	r.RunMethod2("setEllipsize", Mode, "android.text.TextUtils$TruncateAt")
	
End Sub

'DATABASE CALLS
'==============

'SELECT DATABASE RECORDS
'=======================

Sub SelectCodesAvailabilityDescriptionList

	lstAvailabilityDescription(0).Initialize
	
	strSQLQuery = "Select * FROM Codes ORDER BY CodesAvailabilityCode ASC"
	
	WACodesSet = Main.SQLWA.ExecQuery(strSQLQuery)
	
	Do While WACodesSet.NextRow
		lstAvailabilityDescription(0).Add(WACodesSet.GetString("CodesAvailabilityDescription"))
	Loop

	whlAvailabilityDescription.Initialize(Me, Activity, "  Availability  ", 1, lstAvailabilityDescription, 34, 4, False)

End Sub

Sub SelectAvailabilityWCDates
	
	lstAvailabilityWCDate(0).Initialize

	strSQLQuery = "Select AvailabilityWCDate, AvailabilityStatus FROM Availability ORDER BY AvailabilityWCDate ASC"

	WAAvailabilitySet = Main.SQLWA.ExecQuery(strSQLQuery)
	
	Do While WAAvailabilitySet.NextRow
		lstAvailabilityWCDate(0).Add(WAAvailabilitySet.GetString("AvailabilityWCDate"))
		If bolStatusSet = False Then
			strAvailabilityStatus = WAAvailabilitySet.GetString("AvailabilityStatus")
			If strAvailabilityStatus = "D" _
				Or strAvailabilityStatus = "R" Then
					bolStatusSet = True
					intAvailabilityWCDatePos = WAAvailabilitySet.Position
			End If
		End If
	Loop
	
	intTotalAvailabilityRecords = WAAvailabilitySet.RowCount - 1

End Sub

Sub SelectAvailabilityRecord

	strSQLQuery = "Select * FROM Availability WHERE AvailabilityWCDate = ?"

	WAAvailabilitySet = Main.SQLWA.ExecQuery2(strSQLQuery, _
		Array As String(lstAvailabilityWCDate(0).Get(intAvailabilityWCDatePos)))
	
	WAAvailabilitySet.NextRow
	
End Sub

Sub SelectCodesAvailabilityCode
	
	strSQLQuery = "Select CodesAvailabilityCode FROM Codes "
	strSQLQuery = strSQLQuery & "WHERE CodesAvailabilityDescription = ?"

	intCodesAvailabilityCode = Main.SQLWA.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(strCodesAvailabilityDescription))

End Sub

Sub SelectCodesAvailabilityDescription
	
	strSQLQuery = "Select CodesAvailabilityDescription FROM Codes "
	strSQLQuery = strSQLQuery & "WHERE CodesAvailabilityCode = ?"

	strCodesAvailabilityDescription = Main.SQLWA.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(intAvailabilityCodeDay))	

End Sub

'UPDATE DATABASE RECORDS
'=======================

Sub UpdateMondayAvailabilityRecord
	
	strSQLQuery = "UPDATE Availability Set AvailabilityStatus = ?, AvailabilityMonday = ? WHERE AvailabilityWCDate = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strAvailabilityStatus, intCodesAvailabilityCode, strAvailabilityWCDate))
	
End Sub

Sub UpdateMondayAvailabilityCommentsRecord
	
	strSQLQuery = "UPDATE Availability Set AvailabilityStatus = ?, AvailabilityMondayComments = ? WHERE AvailabilityWCDate = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strAvailabilityStatus, strAvailabilityComments, strAvailabilityWCDate))	
	
End Sub

Sub UpdateTuesdayAvailabilityRecord
	
	strSQLQuery = "UPDATE Availability Set AvailabilityStatus = ?, AvailabilityTuesday = ? WHERE AvailabilityWCDate = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strAvailabilityStatus, intCodesAvailabilityCode, strAvailabilityWCDate))	
	
End Sub

Sub UpdateTuesdayAvailabilityCommentsRecord
	
	strSQLQuery = "UPDATE Availability Set AvailabilityStatus = ?, AvailabilityTuesdayComments = ? WHERE AvailabilityWCDate = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strAvailabilityStatus, strAvailabilityComments, strAvailabilityWCDate))	
	
End Sub

Sub UpdateWednesdayAvailabilityRecord
	
	strSQLQuery = "UPDATE Availability Set AvailabilityStatus = ?, AvailabilityWednesday = ? WHERE AvailabilityWCDate = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strAvailabilityStatus, intCodesAvailabilityCode, strAvailabilityWCDate))	
	
End Sub

Sub UpdateWednesdayAvailabilityCommentsRecord
	
	strSQLQuery = "UPDATE Availability Set AvailabilityStatus = ?, AvailabilityWednesdayComments = ? WHERE AvailabilityWCDate = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strAvailabilityStatus, strAvailabilityComments, strAvailabilityWCDate))	
	
End Sub

Sub UpdateThursdayAvailabilityRecord
	
	strSQLQuery = "UPDATE Availability Set AvailabilityStatus = ?, AvailabilityThursday = ? WHERE AvailabilityWCDate = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strAvailabilityStatus, intCodesAvailabilityCode, strAvailabilityWCDate))	
	
End Sub

Sub UpdateThursdayAvailabilityCommentsRecord
	
	strSQLQuery = "UPDATE Availability Set AvailabilityStatus = ?, AvailabilityThursdayComments = ? WHERE AvailabilityWCDate = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strAvailabilityStatus, strAvailabilityComments, strAvailabilityWCDate))	
	
End Sub

Sub UpdateFridayAvailabilityRecord
	
	strSQLQuery = "UPDATE Availability Set AvailabilityStatus = ?, AvailabilityFriday = ? WHERE AvailabilityWCDate = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strAvailabilityStatus, intCodesAvailabilityCode, strAvailabilityWCDate))	
	
End Sub

Sub UpdateFridayAvailabilityCommentsRecord
	
	strSQLQuery = "UPDATE Availability Set AvailabilityStatus = ?, AvailabilityFridayComments = ? WHERE AvailabilityWCDate = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strAvailabilityStatus, strAvailabilityComments, strAvailabilityWCDate))	
	
End Sub

Sub UpdateSaturdayAvailabilityRecord
	
	strSQLQuery = "UPDATE Availability Set AvailabilityStatus = ?, AvailabilitySaturday = ? WHERE AvailabilityWCDate = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strAvailabilityStatus, intCodesAvailabilityCode, strAvailabilityWCDate))	
	
End Sub

Sub UpdateSaturdayAvailabilityCommentsRecord
	
	strSQLQuery = "UPDATE Availability Set AvailabilityStatus = ?, AvailabilitySaturdayComments = ? WHERE AvailabilityWCDate = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strAvailabilityStatus, strAvailabilityComments, strAvailabilityWCDate))	
	
End Sub

Sub UpdateSundayAvailabilityRecord
	
	strSQLQuery = "UPDATE Availability Set AvailabilityStatus = ?, AvailabilitySunday = ? WHERE AvailabilityWCDate = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strAvailabilityStatus, intCodesAvailabilityCode, strAvailabilityWCDate))	
	
End Sub

Sub UpdateSundayAvailabilityCommentsRecord
	
	strSQLQuery = "UPDATE Availability Set AvailabilityStatus = ?, AvailabilitySundayComments = ? WHERE AvailabilityWCDate = ?"
	Log("Sunday Update =" & strAvailabilityComments & "=")
	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strAvailabilityStatus, strAvailabilityComments, strAvailabilityWCDate))	
	
End Sub

Sub UpdateAvailabilityEmailDetails

	strSQLQuery = "UPDATE Availability Set AvailabilityStatus = ?, AvailabilityEmailDateTime = ? WHERE AvailabilityWCDate = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strAvailabilityStatus, strAvailabilityEmailDateTime, strAvailabilityWCDate))	
	
End Sub

'CLICK EVENTS
'============

Sub lblMondayAvailability_Click

	whlAvailabilityDescription.Show2("lblMondayAvailability", lblMondayAvailability.Text)

End Sub

Sub lblMondayAvailabilityComments_Click
	
	pnlComments.Top = 154dip
	
	lblDateDate.Text = lblMondayDate.Text
	lblOldComments.Text = lblMondayAvailabilityComments.Text
	edtNewComments.Tag = lblMonday.Text

	DisplayCommentsPanel

End Sub

Sub lblTuesdayAvailability_Click

	whlAvailabilityDescription.Show2("lblTuesdayAvailability", lblTuesdayAvailability.Text)

End Sub

Sub lblTuesdayAvailabilityComments_Click
	
	pnlComments.Top = 234dip
	
	lblDateDate.Text = lblTuesdayDate.Text
	lblOldComments.Text = lblTuesdayAvailabilityComments.Text
	edtNewComments.Tag = lblTuesday.Text

	DisplayCommentsPanel

End Sub

Sub lblWednesdayAvailability_Click

	whlAvailabilityDescription.Show2("lblWednesdayAvailability", lblWednesdayAvailability.Text)

End Sub

Sub lblWednesdayAvailabilityComments_Click
	
	pnlComments.Top = 314dip
	
	lblDateDate.Text = lblWednesdayDate.Text
	lblOldComments.Text = lblWednesdayAvailabilityComments.Text
	edtNewComments.Tag = lblWednesday.Text

	DisplayCommentsPanel

End Sub

Sub lblThursdayAvailability_Click

	whlAvailabilityDescription.Show2("lblThursdayAvailability", lblThursdayAvailability.Text)

End Sub

Sub lblThursdayAvailabilityComments_Click
	
	pnlComments.Top = 394dip
	lblDateDate.Text = lblThursdayDate.Text
	lblOldComments.Text = lblThursdayAvailabilityComments.Text
	edtNewComments.Tag = lblThursday.Text

	DisplayCommentsPanel

End Sub

Sub lblFridayAvailability_Click

	whlAvailabilityDescription.Show2("lblFridayAvailability", lblFridayAvailability.Text)

End Sub

Sub lblFridayAvailabilityComments_Click
	
	pnlComments.Top = 474dip
	
	lblDateDate.Text = lblFridayDate.Text
	lblOldComments.Text = lblFridayAvailabilityComments.Text
	edtNewComments.Tag = lblFriday.Text

	DisplayCommentsPanel

End Sub

Sub lblSaturdayAvailability_Click

	whlAvailabilityDescription.Show2("lblSaturdayAvailability", lblSaturdayAvailability.Text)

End Sub

Sub lblSaturdayAvailabilityComments_Click
	
	pnlComments.Top = 554dip
	
	lblDateDate.Text = lblSaturdayDate.Text
	lblOldComments.Text = lblSaturdayAvailabilityComments.Text
	edtNewComments.Tag = lblSaturday.Text

	DisplayCommentsPanel

End Sub

Sub lblSundayAvailability_Click

	whlAvailabilityDescription.Show2("lblSundayAvailability", lblSundayAvailability.Text)

End Sub

Sub lblSundayAvailabilityComments_Click
	
	pnlComments.Top = 634dip
	
	lblDateDate.Text = lblSundayDate.Text
	lblOldComments.Text = lblSundayAvailabilityComments.Text
	edtNewComments.Tag = lblSunday.Text
	
	lblEmailToStore.SendToBack

	DisplayCommentsPanel

End Sub

Sub lblCancel_Click
	
	pnlComments.Visible = False

	EnableAllViews

End Sub

Sub lblUpdate_Click
	
	pnlComments.Visible = False
	
	EnableAllViews
	
	If edtNewComments.Text.Length = int0 Then
		edtNewComments.Text = strNoComments
	End If
	
	Select edtNewComments.Tag
		Case lblMonday.Text
			lblMondayAvailabilityComments.Text = edtNewComments.Text
			If lblMondayAvailabilityComments.Text = strNoComments Then
				strAvailabilityComments = strNothing
				lblMondayAvailabilityComments.TextColor = Colors.LightGray
			Else
				strAvailabilityComments = lblMondayAvailabilityComments.Text
				lblMondayAvailabilityComments.TextColor = Colors.Yellow
			End If
			strAvailabilityStatus = strR
			UpdateMondayAvailabilityCommentsRecord
		Case lblTuesday.Text
			lblTuesdayAvailabilityComments.Text = edtNewComments.Text
			If lblTuesdayAvailabilityComments.Text = strNoComments Then
				strAvailabilityComments = strNothing
				lblTuesdayAvailabilityComments.TextColor = Colors.LightGray
			Else
				strAvailabilityComments = lblTuesdayAvailabilityComments.Text
				lblTuesdayAvailabilityComments.TextColor = Colors.Yellow
			End If
			strAvailabilityStatus = strR
			UpdateTuesdayAvailabilityCommentsRecord
		Case lblWednesday.Text
			lblWednesdayAvailabilityComments.Text = edtNewComments.Text
			If lblWednesdayAvailabilityComments.Text = strNoComments Then
				strAvailabilityComments = strNothing
				lblWednesdayAvailabilityComments.TextColor = Colors.LightGray
			Else
				strAvailabilityComments = lblWednesdayAvailabilityComments.Text
				lblWednesdayAvailabilityComments.TextColor = Colors.Yellow
			End If
			strAvailabilityStatus = strR
			UpdateWednesdayAvailabilityCommentsRecord
		Case lblThursday.Text
			lblThursdayAvailabilityComments.Text = edtNewComments.Text
			If lblThursdayAvailabilityComments.Text = strNoComments Then
				strAvailabilityComments = strNothing
				lblThursdayAvailabilityComments.TextColor = Colors.LightGray
			Else
				strAvailabilityComments = lblThursdayAvailabilityComments.Text
				lblThursdayAvailabilityComments.TextColor = Colors.Yellow
			End If
			strAvailabilityStatus = strR
			UpdateThursdayAvailabilityCommentsRecord
		Case lblFriday.Text
			lblFridayAvailabilityComments.Text = edtNewComments.Text
			If lblFridayAvailabilityComments.Text = strNoComments Then
				strAvailabilityComments = strNothing
				lblFridayAvailabilityComments.TextColor = Colors.LightGray
			Else
				strAvailabilityComments = lblFridayAvailabilityComments.Text
				lblFridayAvailabilityComments.TextColor = Colors.Yellow
			End If
			strAvailabilityStatus = strR
			UpdateFridayAvailabilityCommentsRecord
		Case lblSaturday.Text
			lblSaturdayAvailabilityComments.Text = edtNewComments.Text
			If lblSaturdayAvailabilityComments.Text = strNoComments Then
				strAvailabilityComments = strNothing
				lblSaturdayAvailabilityComments.TextColor = Colors.LightGray
			Else
				strAvailabilityComments = lblSaturdayAvailabilityComments.Text
				lblSaturdayAvailabilityComments.TextColor = Colors.Yellow
			End If
			strAvailabilityStatus = strR
			UpdateSaturdayAvailabilityCommentsRecord
		Case lblSunday.Text
			lblSundayAvailabilityComments.Text = edtNewComments.Text
			If lblSundayAvailabilityComments.Text = strNoComments Then
				strAvailabilityComments = strNothing
				lblSundayAvailabilityComments.TextColor = Colors.LightGray
			Else
				strAvailabilityComments = lblSundayAvailabilityComments.Text
				lblSundayAvailabilityComments.TextColor = Colors.Yellow
			End If
			strAvailabilityStatus = strR
			UpdateSundayAvailabilityCommentsRecord
	End Select

	SetupEmailMessage
	
	lblMessages.Text = edtNewComments.Tag & " Availability Comments Updated"
	strMessagesText = lblMessages.Text
	timMessages1.Enabled = True
	timMessages2.Enabled = True
	
End Sub

Sub pnlPrev_Click
	
	intAvailabilityWCDatePos = intAvailabilityWCDatePos - 1

	SelectAvailabilityRecord

	DisplayAvailabilityDetails
	
End Sub

Sub pnlNext_Click
	
	intAvailabilityWCDatePos = intAvailabilityWCDatePos + 1

	SelectAvailabilityRecord

	DisplayAvailabilityDetails
	
End Sub

Sub imgExit_Click
	
	Activity.Finish

End Sub

'LONGCLICK EVENTS
'================

Sub lblCurrentWCDate_LongClick

	pnlCurrent.Enabled = False
	pnlCurrent.Visible = False
	lblEmailToStore.Enabled = False
	lblEmailToStore.Visible = False

	SetupSendEmail

	pnlCurrent.Enabled = True
	pnlCurrent.Visible = True
	lblEmailToStore.Enabled = True
	lblEmailToStore.Visible = True

End Sub

'TICK EVENTS
'===========

Sub timMessages1_Tick
		
	If lblMessages.Text = strNothing Then
		lblMessages.Text = strMessagesText
	Else
		lblMessages.Text = strNothing
	End If
	
End Sub

Sub timMessages2_Tick
		
	timMessages1.Enabled = False
	timMessages2.Enabled = False

	lblMessages.TextColor = Colors.White

	lblMessages.Text = strSaveMessagesText
	
End Sub

'CLOSED EVENTS
'=============

Sub lblMondayAvailability_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		lblMondayAvailability.Text = Selection
		strCodesAvailabilityDescription = Selection
		SelectCodesAvailabilityCode
		strAvailabilityStatus = strR
		UpdateMondayAvailabilityRecord
		SetupEmailMessage
		lblMessages.Text = "Monday Availability Updated"
		strMessagesText = lblMessages.Text
		timMessages1.Enabled = True
		timMessages2.Enabled = True
	End If

End Sub

Sub lblTuesdayAvailability_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		lblTuesdayAvailability.Text = Selection
		strCodesAvailabilityDescription = Selection
		SelectCodesAvailabilityCode
		strAvailabilityStatus = strR
		UpdateTuesdayAvailabilityRecord
		SetupEmailMessage
		lblMessages.Text = "Tuesday Availability Updated"
		strMessagesText = lblMessages.Text
		timMessages1.Enabled = True
		timMessages2.Enabled = True
	End If

End Sub

Sub lblWednesdayAvailability_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		lblWednesdayAvailability.Text = Selection
		strCodesAvailabilityDescription = Selection
		SelectCodesAvailabilityCode
		strAvailabilityStatus = strR
		UpdateWednesdayAvailabilityRecord
		SetupEmailMessage
		lblMessages.Text = "Wednesday Availability Updated"
		strMessagesText = lblMessages.Text
		timMessages1.Enabled = True
		timMessages2.Enabled = True
	End If

End Sub

Sub lblThursdayAvailability_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		lblThursdayAvailability.Text = Selection
		strCodesAvailabilityDescription = Selection
		SelectCodesAvailabilityCode
		strAvailabilityStatus = strR
		UpdateThursdayAvailabilityRecord
		SetupEmailMessage
		lblMessages.Text = "Thursday Availability Updated"
		strMessagesText = lblMessages.Text
		timMessages1.Enabled = True
		timMessages2.Enabled = True
	End If

End Sub

Sub lblFridayAvailability_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		lblFridayAvailability.Text = Selection
		strCodesAvailabilityDescription = Selection
		SelectCodesAvailabilityCode
		strAvailabilityStatus = strR
		UpdateFridayAvailabilityRecord
		SetupEmailMessage
		lblMessages.Text = "Friday Availability Updated"
		strMessagesText = lblMessages.Text
		timMessages1.Enabled = True
		timMessages2.Enabled = True
	End If

End Sub

Sub lblSaturdayAvailability_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		lblSaturdayAvailability.Text = Selection
		strCodesAvailabilityDescription = Selection
		SelectCodesAvailabilityCode
		strAvailabilityStatus = strR
		UpdateSaturdayAvailabilityRecord
		SetupEmailMessage
		lblMessages.Text = "Saturday Availability Updated"
		strMessagesText = lblMessages.Text
		timMessages1.Enabled = True
		timMessages2.Enabled = True
	End If

End Sub

Sub lblSundayAvailability_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		lblSundayAvailability.Text = Selection
		strCodesAvailabilityDescription = Selection
		SelectCodesAvailabilityCode
		strAvailabilityStatus = strR
		UpdateSundayAvailabilityRecord
		SetupEmailMessage
		lblMessages.Text = "Sunday Availability Updated"
		strMessagesText = lblMessages.Text
		timMessages1.Enabled = True
		timMessages2.Enabled = True
	End If

End Sub

'ENTER PRESSED EVENTS
'====================

'Sub edtNewComments_EnterPressed
'
''	IME.HideKeyboard
'	
'	EnableAllViews
'		
'End Sub
	
'GENERAL ROUTINES
'================

Sub DisplayAvailabilityDetails
	
	strAvailabilityStatus = WAAvailabilitySet.GetString("AvailabilityStatus")
	strAvailabilityEmailDateTime = WAAvailabilitySet.GetString("AvailabilityEmailDateTime")
	
	If strAvailabilityEmailDateTime = strNothing Then
		lblMessages.Text = strNothing
	Else
		strDisplayDate = strAvailabilityEmailDateTime.SubString2(4,6) & "/" & strAvailabilityEmailDateTime.SubString2(2,4) & "/"
		strDisplayDate = strDisplayDate & strAvailabilityEmailDateTime.SubString2(0,2)
		strDisplayTime = strAvailabilityEmailDateTime.SubString2(6,8) & ":" & strAvailabilityEmailDateTime.SubString2(8,10)
		If strAvailabilityStatus = "E" Then
			lblMessages.Text = "Emailed on " & strDisplayDate & " @ " & strDisplayTime
		Else
			lblMessages.Text = "Updated - Last emailed " & strDisplayDate & " @ " & strDisplayTime
		End If
	End If

	strAvailabilityWCDate = WAAvailabilitySet.GetString("AvailabilityWCDate")
	strDisplayDate = strAvailabilityWCDate
	lngDisplayDate = DateTime.DateParse(strDisplayDate)
	
	lblMondayDate.Text = strDisplayDate.SubString2(4,6) & "/" & strDisplayDate.SubString2(2,4) & "/"
	lblMondayDate.Text = lblMondayDate.Text & strDisplayDate.SubString2(0,2)
	intAvailabilityCodeDay = WAAvailabilitySet.GetInt("AvailabilityMonday")
	SelectCodesAvailabilityDescription
	lblMondayAvailability.Text = strCodesAvailabilityDescription
	strAvailabilityComments = WAAvailabilitySet.GetString("AvailabilityMondayComments")
	If strAvailabilityComments = strNothing Then
		lblMondayAvailabilityComments.Text = strNoComments
		lblMondayAvailabilityComments.TextColor = Colors.LightGray
	Else
		lblMondayAvailabilityComments.Text = strAvailabilityComments
		lblMondayAvailabilityComments.TextColor = Colors.Yellow
	End If
	
	lngDisplayDate = DateTime.Add(lngDisplayDate, 0, 0, 1)
	strDisplayDate = DateTime.Date(lngDisplayDate)
	lblTuesdayDate.Text = strDisplayDate.SubString2(4,6) & "/" & strDisplayDate.SubString2(2,4) & "/"
	lblTuesdayDate.Text = lblTuesdayDate.Text & strDisplayDate.SubString2(0,2)
	intAvailabilityCodeDay = WAAvailabilitySet.GetInt("AvailabilityTuesday")
	SelectCodesAvailabilityDescription
	lblTuesdayAvailability.Text = strCodesAvailabilityDescription
	strAvailabilityComments = WAAvailabilitySet.GetString("AvailabilityTuesdayComments")
	If strAvailabilityComments = strNothing Then
		lblTuesdayAvailabilityComments.Text = strNoComments
		lblTuesdayAvailabilityComments.TextColor = Colors.LightGray
	Else
		lblTuesdayAvailabilityComments.Text = strAvailabilityComments
		lblTuesdayAvailabilityComments.TextColor = Colors.Yellow
	End If
	
	lngDisplayDate = DateTime.Add(lngDisplayDate, 0, 0, 1)
	strDisplayDate = DateTime.Date(lngDisplayDate)
	lblWednesdayDate.Text = strDisplayDate.SubString2(4,6) & "/" & strDisplayDate.SubString2(2,4) & "/"
	lblWednesdayDate.Text = lblWednesdayDate.Text & strDisplayDate.SubString2(0,2)
	intAvailabilityCodeDay = WAAvailabilitySet.GetInt("AvailabilityWednesday")
	SelectCodesAvailabilityDescription
	lblWednesdayAvailability.Text = strCodesAvailabilityDescription
	strAvailabilityComments = WAAvailabilitySet.GetString("AvailabilityWednesdayComments")
	If strAvailabilityComments = strNothing Then
		lblWednesdayAvailabilityComments.Text = strNoComments
		lblWednesdayAvailabilityComments.TextColor = Colors.LightGray
	Else
		lblWednesdayAvailabilityComments.Text = strAvailabilityComments
		lblWednesdayAvailabilityComments.TextColor = Colors.Yellow
	End If
	
	lngDisplayDate = DateTime.Add(lngDisplayDate, 0, 0, 1)
	strDisplayDate = DateTime.Date(lngDisplayDate)
	lblThursdayDate.Text = strDisplayDate.SubString2(4,6) & "/" & strDisplayDate.SubString2(2,4) & "/"
	lblThursdayDate.Text = lblThursdayDate.Text & strDisplayDate.SubString2(0,2)
	intAvailabilityCodeDay = WAAvailabilitySet.GetInt("AvailabilityThursday")
	SelectCodesAvailabilityDescription
	lblThursdayAvailability.Text = strCodesAvailabilityDescription
	strAvailabilityComments = WAAvailabilitySet.GetString("AvailabilityThursdayComments")
	If strAvailabilityComments = strNothing Then
		lblThursdayAvailabilityComments.Text = strNoComments
		lblThursdayAvailabilityComments.TextColor = Colors.LightGray
	Else
		lblThursdayAvailabilityComments.Text = strAvailabilityComments
		lblThursdayAvailabilityComments.TextColor = Colors.Yellow
	End If
	
	lngDisplayDate = DateTime.Add(lngDisplayDate, 0, 0, 1)
	strDisplayDate = DateTime.Date(lngDisplayDate)
	lblFridayDate.Text = strDisplayDate.SubString2(4,6) & "/" & strDisplayDate.SubString2(2,4) & "/"
	lblFridayDate.Text = lblFridayDate.Text & strDisplayDate.SubString2(0,2)
	intAvailabilityCodeDay = WAAvailabilitySet.GetInt("AvailabilityFriday")
	SelectCodesAvailabilityDescription
	lblFridayAvailability.Text = strCodesAvailabilityDescription
	strAvailabilityComments = WAAvailabilitySet.GetString("AvailabilityFridayComments")
	If strAvailabilityComments = strNothing Then
		lblFridayAvailabilityComments.Text = strNoComments
		lblFridayAvailabilityComments.TextColor = Colors.LightGray
	Else
		lblFridayAvailabilityComments.Text = strAvailabilityComments
		lblFridayAvailabilityComments.TextColor = Colors.Yellow
	End If
	
	lngDisplayDate = DateTime.Add(lngDisplayDate, 0, 0, 1)
	strDisplayDate = DateTime.Date(lngDisplayDate)
	lblSaturdayDate.Text = strDisplayDate.SubString2(4,6) & "/" & strDisplayDate.SubString2(2,4) & "/"
	lblSaturdayDate.Text = lblSaturdayDate.Text & strDisplayDate.SubString2(0,2)
	intAvailabilityCodeDay = WAAvailabilitySet.GetInt("AvailabilitySaturday")
	SelectCodesAvailabilityDescription
	lblSaturdayAvailability.Text = strCodesAvailabilityDescription
	strAvailabilityComments = WAAvailabilitySet.GetString("AvailabilitySaturdayComments")
	If strAvailabilityComments = strNothing Then
		lblSaturdayAvailabilityComments.Text = strNoComments
		lblSaturdayAvailabilityComments.TextColor = Colors.LightGray
	Else
		lblSaturdayAvailabilityComments.Text = strAvailabilityComments
		lblSaturdayAvailabilityComments.TextColor = Colors.Yellow
	End If
	
	lngDisplayDate = DateTime.Add(lngDisplayDate, 0, 0, 1)
	strDisplayDate = DateTime.Date(lngDisplayDate)
	lblSundayDate.Text = strDisplayDate.SubString2(4,6) & "/" & strDisplayDate.SubString2(2,4) & "/"
	lblSundayDate.Text = lblSundayDate.Text & strDisplayDate.SubString2(0,2)
	intAvailabilityCodeDay = WAAvailabilitySet.GetInt("AvailabilitySunday")
	SelectCodesAvailabilityDescription
	lblSundayAvailability.Text = strCodesAvailabilityDescription
	strAvailabilityComments = WAAvailabilitySet.GetString("AvailabilitySundayComments")
	If strAvailabilityComments = strNothing Then
		lblSundayAvailabilityComments.Text = strNoComments
		lblSundayAvailabilityComments.TextColor = Colors.LightGray
	Else
		lblSundayAvailabilityComments.Text = strAvailabilityComments
		lblSundayAvailabilityComments.TextColor = Colors.Yellow
	End If
	
	lblCurrentWCDate.Text = lblMondayDate.Text
	
	If intAvailabilityWCDatePos = int0 Then
		lblPrevWC.Text = strNothing
		lblPrevWCDate.Text = strNothing
		pnlPrev.Enabled = False
	Else
		lblPrevWC.Text = strWC
		strDisplayDate = lstAvailabilityWCDate(0).Get(intAvailabilityWCDatePos - 1)
		lblPrevWCDate.Text = strDisplayDate.SubString2(4,6) & "/" & strDisplayDate.SubString2(2,4) & "/"
		lblPrevWCDate.Text = lblPrevWCDate.Text & strDisplayDate.SubString2(0,2)
		pnlPrev.Enabled = True
	End If
	
	If intAvailabilityWCDatePos = intTotalAvailabilityRecords Then
		lblNextWC.Text = strNothing
		lblNextWCDate.Text = strNothing
		pnlNext.Enabled = False
	Else
		lblNextWC.Text = strWC
		strDisplayDate = lstAvailabilityWCDate(0).Get(intAvailabilityWCDatePos + 1)
		lblNextWCDate.Text = strDisplayDate.SubString2(4,6) & "/" & strDisplayDate.SubString2(2,4) & "/"
		lblNextWCDate.Text = lblNextWCDate.Text & strDisplayDate.SubString2(0,2)
		pnlNext.Enabled = True
	End If

End Sub

Sub SetupEmailMessage
	
	If strAvailabilityEmailDateTime = strNothing Then
		strSaveMessagesText = lblMessages.Text
	Else
		strDisplayDate = strAvailabilityEmailDateTime.SubString2(4,6) & "/" & strAvailabilityEmailDateTime.SubString2(2,4) & "/"
		strDisplayDate = strDisplayDate & strAvailabilityEmailDateTime.SubString2(0,2)
		strDisplayTime = strAvailabilityEmailDateTime.SubString2(6,8) & ":" & strAvailabilityEmailDateTime.SubString2(8,10)
		strSaveMessagesText = "Updated - Last emailed " & strDisplayDate & " @ " & strDisplayTime
	End If

End Sub

Sub DisplayCommentsPanel

	lblMondayAvailability.Enabled = False
	lblMondayAvailabilityComments.Enabled = False
	lblTuesdayAvailability.Enabled = False
	lblTuesdayAvailabilityComments.Enabled = False
	lblWednesdayAvailability.Enabled = False
	lblWednesdayAvailabilityComments.Enabled = False
	lblThursdayAvailability.Enabled = False
	lblThursdayAvailabilityComments.Enabled = False
	lblFridayAvailability.Enabled = False
	lblFridayAvailabilityComments.Enabled = False
	lblSaturdayAvailability.Enabled = False
	lblSaturdayAvailabilityComments.Enabled = False
	lblSundayAvailability.Enabled = False
	lblSundayAvailabilityComments.Enabled = False
	pnlPrev.Enabled = False
	lblCurrentWCDate.Enabled = False
	pnlNext.Enabled = False
	imgExit.Enabled = False

	If lblOldComments.Text = strNoComments Then
		lblOldComments.TextColor = Colors.LightGray
	Else
		lblOldComments.TextColor = Colors.White
	End If
	edtNewComments.Text = strNothing
	edtNewComments.SelectionStart = int0

	pnlComments.Visible = True
	
	IME.ShowKeyboard(edtNewComments)

End Sub

Sub EnableAllViews
	
	IME.HideKeyboard

	lblEmailToStore.BringToFront
	
	lblMondayAvailability.Enabled = True
	lblMondayAvailabilityComments.Enabled = True
	lblTuesdayAvailability.Enabled = True
	lblTuesdayAvailabilityComments.Enabled = True
	lblWednesdayAvailability.Enabled = True
	lblWednesdayAvailabilityComments.Enabled = True
	lblThursdayAvailability.Enabled = True
	lblThursdayAvailabilityComments.Enabled = True
	lblFridayAvailability.Enabled = True
	lblFridayAvailabilityComments.Enabled = True
	lblSaturdayAvailability.Enabled = True
	lblSaturdayAvailabilityComments.Enabled = True
	lblSundayAvailability.Enabled = True
	lblSundayAvailabilityComments.Enabled = True
	pnlPrev.Enabled = True
	lblCurrentWCDate.Enabled = True
	pnlNext.Enabled = True
	imgExit.Enabled = True

End Sub

Sub SetupSendEmail

	strEmailTitle = "Work Availability - Linda Halsey w/c " & lblMondayDate.Text
	If strAvailabilityStatus = strR Then
		strEmailTitle = "Revised " & strEmailTitle
	End If

	CSB.Initialize.Append("<!DOCTYPE html>")
	
	CSB.Append("<html>")

	CSB.Append("<p>Hi</p><p></p><p>")
	CSB.Append("Please find detailed below my ")
	If strAvailabilityStatus = strR Then
		CSB.Append("revised ")
	End If
	CSB.Append("availability for w/c " & lblMondayDate.Text & "</p>")
	CSB.Append("<p></p><p></p>").Append("Thank you.").Append("<p></p><p></p>").Append("Linda Halsey")
	
	CSB.PopAll
	
	strEmailHeader = CSB
	
	CSB.Initialize

	CSB.Append("<head> <style>table th {text-align: left;} </style> </head>")
	CSB.Append("<body>")

	CSB.Append("<table style=" & "width:25%" & "><h2>")
	If strAvailabilityStatus = strR Then
		CSB.Append("Revised ")
	End If
	CSB.Append("Work Availability w/c " & lblMondayDate.Text & "</h2>")
	
	CSB.Append("<tr> <th>Date</th>")
	CSB.Append("<th>Day</th>")
	CSB.Append("<th>Availability</th> </tr>")
	
	CSB.Append("<tr> <td>" & lblMondayDate.Text & "</td>")
	CSB.Append("<td>" & lblMonday.Text & "</td>")
	CSB.Append("<td>" & lblMondayAvailability.Text & "</td> </tr>")
	If lblMondayAvailabilityComments.Text <> strNoComments Then
		CSB.Append("<tr> <td></td> <td></td> <td>" & lblMondayAvailabilityComments.Text & "</td> </tr>")
	End If
	
	CSB.Append("<tr> <td>" & lblTuesdayDate.Text & "</td>")
	CSB.Append("<td>" & lblTuesday.Text & "</td>")
	CSB.Append("<td>" & lblTuesdayAvailability.Text & "</td> </tr>")
	If lblTuesdayAvailabilityComments.Text <> strNoComments Then
		CSB.Append("<tr> <td></td> <td></td> <td>" & lblTuesdayAvailabilityComments.Text & "</td> </tr>")
	End If
	
	CSB.Append("<tr> <td>" & lblWednesdayDate.Text & "</td>")
	CSB.Append("<td>" & lblWednesday.Text & "</td>")
	CSB.Append("<td>" & lblWednesdayAvailability.Text & "</td> </tr>")
	If lblWednesdayAvailabilityComments.Text <> strNoComments Then
		CSB.Append("<tr> <td></td> <td></td> <td>" & lblWednesdayAvailabilityComments.Text & "</td> </tr>")
	End If

	CSB.Append("<tr> <td>" & lblThursdayDate.Text & "</td>")
	CSB.Append("<td>" & lblThursday.Text & "</td>")
	CSB.Append("<td>" & lblThursdayAvailability.Text & "</td> </tr>")
	If lblThursdayAvailabilityComments.Text <> strNoComments Then
		CSB.Append("<tr> <td></td> <td></td> <td>" & lblThursdayAvailabilityComments.Text & "</td> </tr>")
	End If

	CSB.Append("<tr> <td>" & lblFridayDate.Text & "</td>")
	CSB.Append("<td>" & lblFriday.Text & "</td>")
	CSB.Append("<td>" & lblFridayAvailability.Text & "</td> </tr>")
	If lblFridayAvailabilityComments.Text <> strNoComments Then
		CSB.Append("<tr> <td></td> <td></td> <td>" & lblFridayAvailabilityComments.Text & "</td> </tr>")
	End If

	CSB.Append("<tr> <td>" & lblSaturdayDate.Text & "</td>")
	CSB.Append("<td>" & lblSaturday.Text & "</td>")
	CSB.Append("<td>" & lblSaturdayAvailability.Text & "</td> </tr>")
	If lblSaturdayAvailabilityComments.Text <> strNoComments Then
		CSB.Append("<tr> <td></td> <td></td> <td>" & lblSaturdayAvailabilityComments.Text & "</td> </tr>")
	End If
	
	CSB.Append("<tr> <td>" & lblSundayDate.Text & "</td>")
	CSB.Append("<td>" & lblSunday.Text & "</td>")
	CSB.Append("<td>" & lblSundayAvailability.Text & "</td> </tr>")
	If lblSundayAvailabilityComments.Text <> strNoComments Then
		CSB.Append("<tr> <td></td> <td></td> <td>" & lblSundayAvailabilityComments.Text & "</td> </tr>")
	End If
	
	CSB.Append("</table>")
	CSB.Append("</body>")
	CSB.Append("</html>")
	
	CSB.PopAll
	
	strEmailDetail = CSB

	strEmailBody = strEmailHeader & strEmailDetail

	SendEmail
	
End Sub

Sub SendEmail
		
	Dim res As ResumableSub = emEmail.SendEmail(strEmailTitle, strEmailBody, mapPhotos)

	Wait For(res) Complete (Success As Boolean)
	
	ProgressDialogHide
	
	If Success = False Then
		Main.spl.Play(Main.splWarning, 1, 1, 1, 0, 1)
		strSaveMessagesText = lblMessages.Text
		lblMessages.Text = "*** Email Settings Error ***"
		strMessagesText = lblMessages.Text
		lblMessages.TextColor = Colors.Red
		timMessages1.Enabled = True
		timMessages2.Enabled = True
	End If

End Sub

Sub SMTP_MessageSent(Success As Boolean)
	
	If Success Then
		strAvailabilityStatus = "E"
		strAvailabilityEmailDateTime = DateTime.Date(DateTime.Now)
		strAvailabilityEmailDateTime = strAvailabilityEmailDateTime & DateTime.Time(DateTime.Now)
		UpdateAvailabilityEmailDetails
		strDisplayDate = strAvailabilityEmailDateTime.SubString2(4,6) & "/" & strAvailabilityEmailDateTime.SubString2(2,4) & "/"
		strDisplayDate = strDisplayDate & strAvailabilityEmailDateTime.SubString2(0,2)
		strDisplayTime = strAvailabilityEmailDateTime.SubString2(6,8) & ":" & strAvailabilityEmailDateTime.SubString2(8,10)
		lblMessages.Text = "Emailed on " & strDisplayDate & " @ " & strDisplayTime
		Main.spl.Play(Main.splPing, 1, 1, 1, 0, 1)
	Else
		Log(LastException.Message)
		Main.spl.Play(Main.splWarning, 1, 1, 1, 0, 1)
		strSaveMessagesText = lblMessages.Text
		lblMessages.Text = "*** Error Sending Email ***"
		strMessagesText = lblMessages.Text
		lblMessages.TextColor = Colors.Red
		timMessages1.Enabled = True
		timMessages2.Enabled = True
	End If
	
End Sub